'''Collection of constants grouped into data classes. Use it to pass arguments.'''


class CATEGORY:
    '''Corp Announcements category names'''

    AGM = 'AGM/EGM'
    BOARD_MEETING = 'Board Meeting'
    UPDATE = 'Company Update'
    ACTION = 'Corp`.` Action'
    INSIDER = 'Insider Trading / SAST'
    NEW_LISTING = 'New Listing'
    RESULT = 'Result'
    OTHERS = 'Others'


# segments
class SEGMENT:
    '''BSE Market segments'''

    EQUITY = 'Equity'
    MF = 'MF'
    PREFERENCE_SHARES = 'Preference Shares'
    DEBENTURES_BONDS = 'Debentures and Bonds'
    EQUITY_INSTITUTIONAL = 'Equity - Institutional Series'
    COMMERCIAL_PAPERS = 'Commercial Papers'


# status
class STATUS:
    '''Current status of the Financial instrument'''

    ACTIVE = 'Active'
    SUSPENDED = 'Suspended'
    DELISTED = 'Delisted'


class INDEX:
    '''BSE Market Indices'''

    SENSEX = 'S&P BSE SENSEX'
    BSE100 = 'S&P BSE 100'
    BSE100_ESG = 'S&P BSE 100 ESG INDEX'
    BSE100_LARGECAP_TMC = 'S&P BSE 100 LARGECAP TMC INDEX'
    BSE150_MIDCAP = 'S&P BSE 150 MIDCAP INDEX'
    BSE200 = 'S&P BSE 200'
    BSE250_LARGEMIDCAP = 'S&P BSE 250 LARGEMIDCAP INDEX'
    BSE250_SMALLCAP = 'S&P BSE 250 SMALLCAP INDEX'
    BSE400_MIDSMALLCAP = 'S&P BSE 400 MIDSMALLCAP INDEX'
    BSE500 = 'S&P BSE 500'
    ALLCAP = 'S&P BSE ALLCAP'
    AUTO = 'S&P BSE AUTO'
    BANKEX = 'S&P BSE BANKEX'
    BHARAT_22 = 'S&P BSE BHARAT 22 INDEX'
    CAPITAL_GOODS = 'S&P BSE CAPITAL GOODS'
    CARBONEX = 'S&P BSE CARBONEX'
    COMMODITIES = 'S&P BSE COMMODITIES'
    CONSUMER_DISCRETIONARY = 'S&P BSE CONSUMER DISCRETIONARY'
    CONSUMER_DURABLES = 'S&P BSE CONSUMER DURABLES'
    CPSE = 'S&P BSE CPSE'
    DIVERSIFIED_FINANCIALS_REVENUE_GROWTH = 'S&P BSE DIVERSIFIED FINANCIALS REVENUE GROWTH INDEX'
    DIVIDEND_STABILITY = 'S&P BSE DIVIDEND STABILITY INDEX'
    DOLLEX_100 = 'S&P BSE DOLLEX 100'
    DOLLEX_200 = 'S&P BSE DOLLEX 200'
    DOLLEX_30 = 'S&P BSE DOLLEX 30'
    ENERGY = 'S&P BSE ENERGY'
    ENHANCED_VALUE = 'S&P BSE ENHANCED VALUE INDEX'
    FAST_MOVING_CONSUMER_GOODS = 'S&P BSE FAST MOVING CONSUMER GOODS'
    FINANCIAL_SERVICES = 'S&P BSE FINANCIAL SERVICES'
    GREENEX = 'S&P BSE GREENEX'
    HEALTHCARE = 'S&P BSE HEALTHCARE'
    INDIA_INFRASTRUCTURE = 'S&P BSE INDIA INFRASTRUCTURE INDEX'
    INDIA_MANUFACTURING = 'S&P BSE INDIA MANUFACTURING INDEX'
    INDUSTRIALS = 'S&P BSE INDUSTRIALS'
    INFORMATION_TECHNOLOGY = 'S&P BSE INFORMATION TECHNOLOGY'
    IPO = 'S&P BSE IPO'
    LARGECAP = 'S&P BSE LARGECAP'
    LOW_VOLATILITY = 'S&P BSE LOW VOLATILITY INDEX'
    METAL = 'S&P BSE METAL'
    MIDCAP = 'S&P BSE MIDCAP'
    MIDCAP_SELECT = 'S&P BSE MIDCAP SELECT INDEX'
    MOMENTUM = 'S&P BSE MOMENTUM INDEX'
    OIL_GAS = 'S&P BSE OIL & GAS'
    POWER = 'S&P BSE POWER'
    PRIVATE_BANKS = 'S&P BSE PRIVATE BANKS INDEX'
    PSU = 'S&P BSE PSU'
    QUALITY = 'S&P BSE QUALITY INDEX '
    REALTY = 'S&P BSE REALTY'
    SENSEX_50 = 'S&P BSE SENSEX 50'
    SENSEX_NEXT_50 = 'S&P BSE SENSEX NEXT 50'
    SERVICES = 'S&P BSE SERVICES'
    SMALLCAP = 'S&P BSE SMALLCAP'
    SMALLCAP_SELECT = 'S&P BSE SMALLCAP SELECT INDEX'
    SME_IPO = 'S&P BSE SME IPO'
    TECK = 'S&P BSE TECK'
    TELECOMMUNICATION = 'S&P BSE TELECOMMUNICATION'
    UTILITIES = 'S&P BSE UTILITIES'


class PURPOSE:
    '''Corp Actions purpose code'''

    BONUS = 'P5'
    BUYBACK = 'P6'
    DIVIDEND = 'P9'
    PREFERENCE_DIVIDEND = 'P10'
    SPLIT = 'P26'
    DELISTING = 'P29'


# Sector
class SECTOR:
    '''BSE Sector names'''

    AUTO = 'Automobile and Auto Components'
    CAPITAL_GOODS = 'Capital Goods'
    CHEMICALS = 'Chemicals'
    CONSTRUCTION = 'Construction'
    CONSTRUCTION_MATERIALS = 'Construction Materials'
    CONSUMER_DURABLES = 'Consumer Durables'
    CONSUMER_SERVICES = 'Consumer Services'
    DIVERSIFIED = 'Diversified'
    FMCG = 'Fast Moving Consumer Goods'
    FIN_SERVICES = 'Financial Services'
    FOREST_MATERIALS = 'Forest Materials'
    IT = 'Information Technology'
    MEDIA = 'Media, Entertainment & Publication'
    METAL_MINING = 'Metals & Mining'
    OIL_GAS = 'Oil, Gas & Consumable Fuels'
    POWER = 'Power'
    REALTY = 'Realty'
    SERVICES = 'Services'
    TELECOM = 'Telecommunication'
    TEXTILES = 'Textiles'
    UTILITIES = 'Utilities'


class SECTOR_ISIN:
    '''ISIN code for BSE Sectors'''

    AUTOMOBILE = 'IN020102001'
    CAPITAL_GOODS = 'IN070205008'
    CHEMICALS = 'IN010101001'
    CONSTRUCTION = 'IN070101001'
    CONSTRUCTION_MATERIALS = 'IN010203001'
    CONSUMER_DURABLES = 'IN020201003'
    CONSUMER_SERVICES = 'IN020601001'
    DIVERSIFIED = 'IN120101001'
    FMCG = 'IN040101003'
    FIN_SERVICES = 'IN050103006'
    FOREST_MATERIALS = 'IN010401001'
    HEALTHCARE = 'IN060101001'
    IT = 'IN080102001'
    MEDIA = 'IN020401001'
    METALS = 'IN010301001'
    OIL_GAS = 'IN030103001'
    POWER = 'IN110101002'
    REALTY = 'IN020501001'
    SERVICES = 'IN090104002'
    TELECOMMUNICATION = 'IN100101003'
    TEXTILES = 'IN020301002'
    UTILITIES = 'IN110201005'


class INDUSTRY:
    '''BSE Industry names'''

    TWO_WHEELERS = '2/3 WHEELERS'
    ABRASIVES_BEARINGS = 'ABRASIVES & BEARINGS'
    ADVERTISING = 'ADVERTISING & MEDIA AGENCIES'
    AEROSPACE_DEFENSE = 'AEROSPACE & DEFENSE'
    AIRLINE = 'AIRLINE'
    AIRPORT_SERVICES = 'AIRPORT & AIRPORT SERVICES'
    ALUMINIUM = 'ALUMINIUM'
    ALUMINIUM_COPPER_ZINC = 'ALUMINIUM, COPPER & ZINC PRODUCTS'
    AMUSEMENT_PARKS = 'AMUSEMENT PARKS/ OTHER RECREATION'
    ANIMAL_FEED = 'ANIMAL FEED'
    ASSET_MANAGEMENT = 'ASSET MANAGEMENT COMPANY'
    AUTO_COMPONENTS = 'AUTO COMPONENTS & EQUIPMENTS'
    AUTO_DEALER = 'AUTO -DEALER'
    BIOTECHNOLOGY = 'BIOTECHNOLOGY'
    BREWERIES = 'BREWERIES & DISTILLERIES'
    BPO_KPO = 'BUSINESS PROCESS OUTSOURCING (BPO)/ KNOWLEDGE PROCESS OUTSOURCING (KPO)'
    CABLES_ELECTRICALS = 'CABLES - ELECTRICALS'
    CARBON_BLACK = 'CARBON BLACK'
    CASTINGS_FORGINGS = 'CASTINGS & FORGINGS'
    CEMENT = 'CEMENT & CEMENT PRODUCTS'
    CERAMICS = 'CERAMICS'
    TOBACCO = 'CIGARETTES & TOBACCO PRODUCTS'
    CIVIL_CONSTRUCTION = 'CIVIL CONSTRUCTION'
    COAL = 'COAL'
    COMMERCIAL_VEHICLES = 'COMMERCIAL VEHICLES'
    COMMODITY_CHEMICALS = 'COMMODITY CHEMICALS'
    COMPRESSORS_PUMPS_ENGINES = 'COMPRESSORS, PUMPS & DIESEL ENGINES'
    IT_SOFTWARE = 'COMPUTERS - SOFTWARE & CONSULTING'
    IT_HARDWARE = 'COMPUTERS HARDWARE & EQUIPMENTS'
    CONSTRUCTION_VEHICLES = 'CONSTRUCTION VEHICLES'
    CONSULTING_SERVICES = 'CONSULTING SERVICES'
    CONSUMER_ELECTRONICS = 'CONSUMER ELECTRONICS'
    COPPER = 'COPPER'
    CYCLES = 'CYCLES'
    DAIRY_PRODUCTS = 'DAIRY PRODUCTS'
    DATA_PROCESSING = 'DATA PROCESSING SERVICES'
    DEPOSITORIES_CLEARING_HOUSES = 'DEPOSITORIES, CLEARING HOUSES AND OTHER INTERMEDIARIES'
    DIGITAL_ENTERTAINMENT = 'DIGITAL ENTERTAINMENT'
    DISTRIBUTORS = 'DISTRIBUTORS'
    DIVERSIFIED = 'DIVERSIFIED'
    DIVERSIFIED_COMMERCIAL = 'DIVERSIFIED COMMERCIAL SERVICES'
    DIVERSIFIED_CONSUMER = 'DIVERSIFIED CONSUMER PRODUCTS'
    DIVERSIFIED_FMCG = 'DIVERSIFIED FMCG'
    DIVERSIFIED_METALS = 'DIVERSIFIED METALS'
    DIVERSIFIED_RETAIL = 'DIVERSIFIED RETAIL'
    DREDGING = 'DREDGING'
    DYES_AND_PIGMENTS = 'DYES AND PIGMENTS'
    EDIBLE_OIL = 'EDIBLE OIL'
    EDUCATION = 'EDUCATION'
    ELEARNING = 'E-LEARNING'
    ELECTRODES_REFRACTORIES = 'ELECTRODES & REFRACTORIES'
    ELECTRONIC_MEDIA = 'ELECTRONIC MEDIA'
    ECOMMERCE = 'E-RETAIL/ E-COMMERCE'
    EXCHANGE_PLATFORM = 'EXCHANGE AND DATA PLATFORM'
    EXPLOSIVES = 'EXPLOSIVES'
    FERRO_SILICA_MANGANESE = 'FERRO & SILICA MANGANESE'
    FERTILIZERS = 'FERTILIZERS'
    FILM_PRODUCTION = 'FILM PRODUCTION, DISTRIBUTION & EXHIBITION'
    FINANCIAL_INSTITUTION = 'FINANCIAL INSTITUTION'
    FINANCIAL_PRODUCTS = 'FINANCIAL PRODUCTS DISTRIBUTOR'
    FINTECH = 'FINANCIAL TECHNOLOGY (FINTECH)'
    FOOD_STORAGE = 'FOOD STORAGE FACILITIES'
    FOOTWEAR = 'FOOTWEAR'
    FOREST_PRODUCTS = 'FOREST PRODUCTS'
    FURNITURE_HOME_FURNISHING = 'FURNITURE, HOME FURNISHING'
    FURNITURE_HOME_FURNISHING_FLOORING = 'FURNITURE, HOME FURNISHING, FLOORING'
    GARMENTS_APPARELS = 'GARMENTS & APPARELS'
    GAS_TRANSMISSION = 'GAS TRANSMISSION/MARKETING'
    JEWELLERY = 'GEMS, JEWELLERY AND WATCHES'
    GENERAL_INSURANCE = 'GENERAL INSURANCE'
    GLASS_CONSUMER = 'GLASS - CONSUMER'
    GLASS_INDUSTRIAL = 'GLASS - INDUSTRIAL'
    GRANITES_MARBLES = 'GRANITES & MARBLES'
    HEALTHCARE = 'HEALTHCARE RESEARCH, ANALYTICS & TECHNOLOGY'
    HEALTHCARE_SERVICE = 'HEALTHCARE SERVICE PROVIDER'
    HEAVY_ELECTRICAL = 'HEAVY ELECTRICAL EQUIPMENT'
    HOLDING_COMPANY = 'HOLDING COMPANY'
    HOSPITAL = 'HOSPITAL'
    HOTELS_RESORTS = 'HOTELS & RESORTS'
    HOUSEHOLD_APPLIANCES = 'HOUSEHOLD APPLIANCES'
    HOUSEHOLD_PRODUCTS = 'HOUSEHOLD PRODUCTS'
    HOUSEWARE = 'HOUSEWARE'
    HOUSING_FINANCE_COMPANY = 'HOUSING FINANCE COMPANY'
    INDUSTRIAL_GASES = 'INDUSTRIAL GASES'
    INDUSTRIAL_MACHINERY = 'INDUSTRIAL MACHINERY'
    INDUSTRIAL_MINERALS = 'INDUSTRIAL MINERALS'
    INDUSTRIAL_PRODUCTS = 'INDUSTRIAL PRODUCTS'
    INTEGRATED_POWER_UTILITIES = 'INTEGRATED POWER UTILITIES'
    INTERNET_CATALOGUE_RETAIL = 'INTERNET & CATALOGUE RETAIL'
    INVESTMENT_COMPANY = 'INVESTMENT COMPANY'
    IRON_STEEL = 'IRON & STEEL'
    IRON_STEEL_PRODUCTS = 'IRON & STEEL PRODUCTS'
    IT_ENABLED_SERVICES = 'IT ENABLED SERVICES'
    JUTE_JUTE_PRODUCTS = 'JUTE & JUTE PRODUCTS'
    LEATHER_AND_LEATHER_PRODUCTS = 'LEATHER AND LEATHER PRODUCTS'
    LEISURE_PRODUCTS = 'LEISURE PRODUCTS'
    LIFE_INSURANCE = 'LIFE INSURANCE'
    LOGISTICS_SOLUTION_PROVIDER = 'LOGISTICS SOLUTION PROVIDER'
    LPG_CNG_PNG_LNG = 'LPG/CNG/PNG/LNG SUPPLIER'
    LUBRICANTS = 'LUBRICANTS'
    MEAT_PRODUCTS_INCLUDING_POULTRY = 'MEAT PRODUCTS INCLUDING POULTRY'
    MEDIA_ENTERTAINMENT = 'MEDIA & ENTERTAINMENT'
    MEDICAL_EQUIPMENT_SUPPLIES = 'MEDICAL EQUIPMENT & SUPPLIES'
    MICROFINANCE_INSTITUTIONS = 'MICROFINANCE INSTITUTIONS'
    MUTUAL_FUND = 'MUTUAL FUND SCHEME - ETF'
    NBFC = 'NON BANKING FINANCIAL COMPANY (NBFC)'
    OFFSHORE_DRILLING = 'OFFSHORE SUPPORT SOLUTION DRILLING'
    OIL_EQUIPMENT_SERVICES = 'OIL EQUIPMENT & SERVICES'
    OIL_EXPLORATION_PRODUCTION = 'OIL EXPLORATION & PRODUCTION'
    OIL_STORAGE_TRANSPORT = 'OIL STORAGE & TRANSPORTATION'
    OTHER_AGRICULTURAL_PRODUCTS = 'OTHER AGRICULTURAL PRODUCTS'
    OTHER_BANK = 'OTHER BANK'
    OTHER_BEVERAGES = 'OTHER BEVERAGES'
    OTHER_CAPITAL_MARKET_SERVICES = 'OTHER CAPITAL MARKET RELATED SERVICES'
    OTHER_CONSTRUCTION_MATERIALS = 'OTHER CONSTRUCTION MATERIALS'
    OTHER_CONSUMER_SERVICES = 'OTHER CONSUMER SERVICES'
    OTHER_ELECTRICAL_EQUIPMENT = 'OTHER ELECTRICAL EQUIPMENT'
    OTHER_FINANCIAL_SERVICES = 'OTHER FINANCIAL SERVICES'
    OTHER_FOOD_PRODUCTS = 'OTHER FOOD PRODUCTS'
    OTHER_INDUSTRIAL_PRODUCTS = 'OTHER INDUSTRIAL PRODUCTS'
    OTHER_TELECOM_SERVICES = 'OTHER TELECOM SERVICES'
    OTHER_TEXTILE_PRODUCTS = 'OTHER TEXTILE PRODUCTS'
    OTHER_UTILITIES = 'OTHER UTILITIES'
    PACKAGED_FOODS = 'PACKAGED FOODS'
    PACKAGING = 'PACKAGING'
    PAINTS = 'PAINTS'
    PAPER_PAPER_PRODUCTS = 'PAPER & PAPER PRODUCTS'
    PASSENGER_CARS_UTILITY_VEHICLES = 'PASSENGER CARS & UTILITY VEHICLES'
    PERSONAL_CARE = 'PERSONAL CARE'
    PESTICIDES_AGROCHEMICALS = 'PESTICIDES & AGROCHEMICALS'
    PETROCHEMICALS = 'PETROCHEMICALS'
    PHARMACEUTICALS = 'PHARMACEUTICALS'
    PHARMACY_RETAIL = 'PHARMACY RETAIL'
    PHOTOGRAPHIC_PRODUCTS = 'PHOTOGRAPHIC PRODUCTS'
    PIG_IRON = 'PIG IRON'
    PLASTIC_PRODUCTS_CONSUMER = 'PLASTIC PRODUCTS - CONSUMER'
    PLASTIC_PRODUCTS_INDUSTRIAL = 'PLASTIC PRODUCTS - INDUSTRIAL'
    PLYWOOD_BOARDS_LAMINATES = 'PLYWOOD BOARDS/ LAMINATES'
    PORT_SERVICES = 'PORT & PORT SERVICES'
    POWER_TRANSMISSION = 'POWER - TRANSMISSION'
    POWER_GENERATION = 'POWER GENERATION'
    POWER_TRADING = 'POWER TRADING'
    PRECIOUS_METALS = 'PRECIOUS METALS'
    PRINT_MEDIA = 'PRINT MEDIA'
    PRINTING_PUBLICATION = 'PRINTING & PUBLICATION'
    PRINTING_INKS = 'PRINTING INKS'
    PRIVATE_SECTOR_BANK = 'PRIVATE SECTOR BANK'
    PUBLIC_SECTOR_BANK = 'PUBLIC SECTOR BANK'
    RAILWAY_WANS = 'RAILWAY WANS'
    RATINGS = 'RATINGS'
    REITS = 'REAL ESTATE INVESTMENT TRUSTS (REITS)'
    REAL_ESTATE = 'REAL ESTATE RELATED SERVICES'
    REFINERIES_MARKETING = 'REFINERIES & MARKETING'
    RESIDENTIAL_COMMERCIAL_PROJECTS = 'RESIDENTIAL, COMMERCIAL PROJECTS'
    RESTAURANTS = 'RESTAURANTS'
    ROAD_ASSETS = 'ROAD ASSETS–TOLL, ANNUITY, HYBRID-ANNUITY'
    ROAD_TRANSPORT = 'ROAD TRANSPORT'
    RUBBER = 'RUBBER'
    SANITARY_WARE = 'SANITARY WARE'
    SEAFOOD = 'SEAFOOD'
    SHIP_BUILDING = 'SHIP BUILDING & ALLIED SERVICES'
    SHIPPING = 'SHIPPING'
    SOFTWARE_PRODUCTS = 'SOFTWARE PRODUCTS'
    SPECIALITY_RETAIL = 'SPECIALITY RETAIL'
    SPECIALTY_CHEMICALS = 'SPECIALTY CHEMICALS'
    SPONGE_IRON = 'SPONGE IRON'
    STATIONARY = 'STATIONARY'
    STOCKBROKING = 'STOCKBROKING & ALLIED'
    SUGAR = 'SUGAR'
    TEA_COFFEE = 'TEA & COFFEE'
    TELECOM_EQUIPMENT = 'TELECOM -  EQUIPMENT & ACCESSORIES'
    TELECOM_CELLULAR = 'TELECOM - CELLULAR & FIXED LINE SERVICES'
    TELECOM_INFRASTRUCTURE = 'TELECOM - INFRASTRUCTURE'
    TOUR_TRAVEL = 'TOUR, TRAVEL RELATED SERVICES'
    TRACTORS = 'TRACTORS'
    TRADING_AUTO_COMPONENTS = 'TRADING - AUTO COMPONENTS'
    TRADING_CHEMICALS = 'TRADING - CHEMICALS'
    TRADING_GAS = 'TRADING - GAS'
    TRADING_METALS = 'TRADING - METALS'
    TRADING_MINERALS = 'TRADING - MINERALS'
    TRADING_TEXTILE = 'TRADING - TEXTILE PRODUCTS'
    TRADING_DISTRIBUTORS = 'TRADING & DISTRIBUTORS'
    TRADING_COAL = 'TRADING COAL'
    TRANSPORT_RELATED_SERVICES = 'TRANSPORT RELATED SERVICES'
    TV_BROADCASTING = 'TV BROADCASTING & SOFTWARE PRODUCTION'
    TYRES_RUBBER = 'TYRES & RUBBER PRODUCTS'
    WASTE_MANAGEMENT = 'WASTE MANAGEMENT'
    WATER_SUPPLY = 'WATER SUPPLY & MANAGEMENT'
    WELLNESS = 'WELLNESS'
    ZINC = 'ZINC'
